/***************************************************************************
                   INTERNAL FUNCTION PROTOTYPES
****************************************************************************/

/***************************************************************************
                             FILE: REP.C 
****************************************************************************/
BOOL    CALLBACK _export FrEditSubclass(HWND,UINT,WPARAM,LPARAM);
BOOL    FrTranslateAccelerator(HWND,UINT,WPARAM,LPARAM);
BOOL    InGroup(int);
DWORD   sAlloc(UINT); 
DWORD   sReAlloc(DWORD,UINT); 
int     DeselectItem(void);
int     FrAdjustCursorRect(void);
int     FrAdjustScroll(RECT far *);
int     FrDrawFocusRect(HDC,RECT far *);
int     FrDrawOutline(HDC,RECT far *,int);
int     FrDrawRect(HDC,RECT far *);
int     FrEraseFocusRect(HDC,RECT far *);
int     FrFindItemSlot(int);
int     FrInitMenu(HMENU);
int     FrKeyMove(WPARAM);
int     FrMouseDown(WPARAM,LPARAM);
int     FrMouseMove(WPARAM,LPARAM);
int     FrSetCursor(int,int);
int     FrSetCursorShape(DWORD);
int     GetLabelLen(LPSTR,int);
int     GetMouseItem(int,int);
int     GetMouseOpt(DWORD);
int     InitItem(struct StrItem huge *);
int     LeftMostItem(void);
int     MakeRect(RECT far *,int,int,int,int);
int     MarkGroupItems(void);
int     NextGroupItem(void);
int     PosItem(void);
int     RepaintFr(void);
int     SelectGroupItemPartI(int,int);
int     SelectGroupItemPartII(void);
int     SelectItem(int);
int     SetFont(HDC,unsigned char);
int     SetScrollBars(void);
int     TopMostItem(void);
int     sFree(DWORD); 
int     sUnlock(DWORD); 
int     TruncateText(LPSTR,int,int);
int     CALLBACK _export WEP(int);
LRESULT CALLBACK _export FrWndProc(HWND,UINT,WPARAM,LPARAM);
void    DrawDividers(HDC);
void    DrawField(HDC,int);
void    DrawItem(HDC,int);
void    DrawLabel(HDC,int);
void    DrawLine(HDC,int);
void    DrawPicture(HDC,int);
void    DrawOptRects(HDC);
void    DrawSideRuler(HDC,BOOL,int);
void    DrawTopRuler(HDC);
void    DrawTopRuler(HDC);
void    DrawSection(HDC,int);
void    FrPaint(void);
void    FrSetViewWindow(void);
void    GetWinDimension(void);
void    OurFree(void far *);
void    far *OurAlloc(UINT);
void    far *sLock(DWORD); 

/***************************************************************************
                             FILE: REP1.C 
****************************************************************************/
int     CenterItem(void);
int     CompressHorizontal(void);
int     CompressVertical(void);
int     DeleteItem(void);
int     EditItemOutline(void);
int     EditLine(void);
int     EditItemBackground(void);
int     ExpandHorizontal(void);
int     ExpandVertical(void);
int     FrWinLeft(void);
int     FrWinRight(void);
int     FrWinDown(void);
int     FrWinUp(void);
int     CallDialogBox(LPSTR,DLGPROC,DWORD);
int     InsertFieldPartI(int);
int     InsertFieldPartII(void);
int     InsertLabelPartI(void);
int     InsertLabelPartII(void);
int     InsertLinePartI(void);
int     InsertLinePartII(void);
int     InsertPicturePartI(int);
int     InsertPicturePartII(void);
int     MoveEachItem(int,int,int);
int     MoveItem(void);
int     SizeItem(void);
int     SizeSection(void);
int     UpdateLabelSize(int);
int     UpdateLabelText(void);
void    MoveItemArray(int,int,char); 
void    AlignHorzTop(void);
void    AlignHorzBot(void);
void    AlignHorzCenter(void);
void    AlignVertLeft(void);
void    AlignVertRight(void);
void    AlignVertCenter(void);
void    DiscardUndo(void);
void    EvenSizeHorz(void);
void    EvenSizeVert(void);
void    EvenSpaceHorz(void);
void    EvenSpaceVert(void);
void    StoreUndo(void);
void    Undo(void);

/***************************************************************************
                             FILE: REP_BLK.C 
****************************************************************************/
int     PictureFromClipboard(void);
int     PictureFromFile(void);

/***************************************************************************
                             FILE: REP_DLG.C 
****************************************************************************/
BOOL    CALLBACK _export BackgroundParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export CreateDlgParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export DateFieldParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export DlgInputParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export DlgParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export EditSecParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ExpParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export FieldNameParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export FuctParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export LineParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export LogFieldParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ModifyDlgParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export NumFieldParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export OpParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export OutlineParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PrintAbortParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PosParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PrintParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PrinterParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export RepParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ScrPrintAbortParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export SecBreakParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export SecSortParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export SummaryParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export TextFieldParam(HWND,UINT,WPARAM,LPARAM);
COLORREF EditColor(HWND,COLORREF,BOOL);
int     CALLBACK _export CalcParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export DeviceParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export JumpParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export NewSecParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export SumParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export SysParam(HWND,UINT,WPARAM,LPARAM);

/***************************************************************************
                             FILE: REP_EXP.C 
****************************************************************************/
int     RunExp(int far *,struct StrField huge *,int);
char    NextSymbol(LPSTR,LPSTR,int far *);
int     CompileExp(int far *,int far *);
int     ExtractSpecificWord(LPSTR,LPSTR,int);
int     GenerateSymbols(LPSTR,int far *,int far *,int);
int     ModifyExp(int far *,int far *,LPSTR,int);
int     PopStack(int far *,int far *,int far *);
int     PushStack(int far *,int,int far *);
int     calculate(int,int,int,struct StrField huge *,int);
int     calculate1(struct StrField huge *,struct StrField huge *,struct StrField huge *,int,int,int);
int     calculate2(struct StrField huge *,struct StrField huge *,struct StrField huge *,int,int,int);
int     calculate3(struct StrField huge *,struct StrField huge *,struct StrField huge *,int,int,int,int);

/***************************************************************************
                             FILE: REP_FILE.C 
****************************************************************************/
BOOL    CallPrinterDriver(WORD);
BOOL    FrRead(LPSTR);
BOOL    FrSave(LPSTR);
BOOL    FrSaveAs(LPSTR);
BOOL    GetFileName(BOOL,LPSTR,LPSTR);
LPSTR   GetPrinterList(int far *);
int     FrFarRead(HFILE,long,char huge *);
int     FrFarWrite(HFILE,long,char huge *);
int     FrPrintOptions(void);
int     FrRepFilter(void);
int     FrRepParameters(void);
void    HugeMove(void huge *,void huge *,long);

/***************************************************************************
                             FILE: REP_FLD.C 
****************************************************************************/
int     CreateDlgField(void);
int     CreateFieldLabel(int,LPSTR,int,int);
int     DeleteDlgField(void);
int     DlgFieldInUse(int far *,int);
int     FindFieldSlot(void);
int     EditFieldExp(void);
int     GetCalcField(struct StrField huge *);
int     InitField(struct StrField huge *);
int     InsertCalcField(void);
int     InsertDataField(void);
int     InsertDlgField(void);
int     InsertSysField(void);
int     ModifyDlgField(void);
int     ModifyField(void);
int     ModifyFieldExp(struct StrField huge *);
int     ReleaseSymbols(int far *);
void    DeleteField(int);

/***************************************************************************
                             FILE: REP_FMT.C 
****************************************************************************/
BOOL    IsSameFont(LOGFONT far *,LOGFONT far *);
int     CreateOneFont(HDC,int);
int     DeleteFrObject(int);
int     FindOpenSlot(void);
int     FrCreateDIB(HBITMAP);
int     FrFonts(void);
int     FrXlateDIB(HDC,int);
int     InitFrObject(int);
int     SelectBestFont(HDC,int,LPSTR,int);

/***************************************************************************
                             FILE: REP_INI.C 
****************************************************************************/
BOOL    CloseFr(void);
BOOL    InitFr(DWORD,int,int,int,int);
int     AllocArrayMem(void);
int     InitNewForm(void);
int     InitOp(int,LPSTR,int,BOOL,BOOL,BOOL,LPSTR);
int     InitPrinter(void);
int     ProcessPrinterData(void);
int     SetLogicalUnit(HDC);
void    AbortFr(LPSTR,UINT);
void    InitDeviceProp(void);
void    InitVariables(void);

/***************************************************************************
                             FILE: REP_MISC.C 
****************************************************************************/
BOOL    AssignNumVal(HWND,int,int *);
BOOL    CheckDlgValue(HWND,char,int,double,double);
BOOL    CurrentPrinter(LPSTR,LPSTR,LPSTR);
BOOL    ParseProfileString(LPSTR,LPSTR,LPSTR,LPSTR,LPSTR);
BOOL    StringBegins(LPSTR,LPSTR);    
LPSTR   lstrlwr(LPSTR);
LPSTR   lstrupr(LPSTR);
LPSTR   lstrstr(LPSTR,LPSTR);    
LPSTR   DoubleToStr(double,int,LPSTR);
int     ValidateDate(LPSTR,long far *);
int     lPad(LPSTR,int);
int     OurPrintf(LPSTR,...);
int     rPad(LPSTR,int);
long    GetFileLength(LPSTR);
void    StrTrim(LPSTR);
void    lTrim(LPSTR);
void    rTrim(LPSTR);
void    FarMemSet(void far *,char,UINT);
void    FarMove(void far *,void far *,UINT);
void    FarMoveOl(void far *,void far *,UINT);
void    GetSystemDateTime(void);  
UINT    FarCharIndex(LPSTR,char,UINT);
UINT    FarStringIndex(LPSTR,LPSTR);

/***************************************************************************
                             FILE: REP_REP.C 
****************************************************************************/
int     AcceptDlgField(void);
int     AllocRepMem(void);
int     CalculateBreakFields(void);
int     CalculateFields(int,int);
int     CalculateSecExp(int);
int     EvaluateSystemFields(void);
int     ExtractLine(int,LPSTR,int);
int     FormatFieldData(struct StrField huge *,char far *);
int     InitFirstRec(void);
int     PrintItem(HDC,int);
int     PrintField(HDC,int);
int     PrintLabel(HDC,int);
int     PrintLine(HDC,int);
int     PrintPicture(HDC,int);
int     PrintWrapField(HDC,int);
int     PrintSection(int);
int     PrintSortFooters(void);
int     PrintSortHeaders(int);
int     RepCleanup(void);
int     StuffSysField(struct StrField huge *);

/***************************************************************************
                             FILE: REP_REP1.C 
****************************************************************************/
HMETAFILE ReadMetaFilePage(int,LPSTR,HMETAFILE);
int     AdvancePage(int);
int     CALLBACK _export PrintProc(HDC,int);
int     CALLBACK _export ScrPrintProc(HDC,int);
int     CopyFileData(LPSTR,long,LPSTR,long,long); 
int     CreateNewMetaFiles(void);
int     PageJump(void);
int     PaintRepScr(void);
int     PrintTrial(void);
int     ProcessUserCommands(void);
int     RepDown(int);
int     RepInitMenu(HMENU);
int     RepLeft(int);
int     RepRight(int);
int     RepUp(int);
int     RepaintRepScr(void);
int     SelectivePrint(void);
int     ShowScrRepStatus(void);
int     TransferMetaFile(void);
long    CALLBACK _export RepWndProc(HWND,UINT,WPARAM,LPARAM);

LPSTR RepGetCurDir(LPSTR);
/***************************************************************************
                             FILE: REP_SEC.C 
****************************************************************************/
int     DeleteSection(void);
int     EditSection(void);
int     EditSectionBreak(void);
int     EditSectionFilter(void);
int     EditSectionSort(void);
int     NewSection(void);
