#include "rvb_def.h"          // macro definitions

/******************************************************************************
    Common Variables
*******************************************************************************/
PREFIX MODEL    model;                   // model structure

PREFIX HANDLE   hRvbInst;                // DLL instance id 
PREFIX char     TempString[301],         // temporary holding place 
                TempString1[301];        // temporary holding place 

/*******************************************************************************
    Picture information parameter structure
********************************************************************************/
struct StrPict {
      HDC    hDC;               // Device Context of the report output device
      int    PictId;            // picture id value
      int    FileId;            // FileId of the picture
      int    FieldId;           // FieldId of the picture
      int    x;                 // picture location
      int    y;                 // picture location
      int    width;             // picture width
      int    height;            // picture height
};

typedef struct StrPict far *LPPICT;

/*******************************************************************************
    Control Parameter Structure
********************************************************************************/
struct StrCtl {
       struct StrField CurField;
       struct StrField huge *DataField;  // pointer to an array of output fields used by the 
       struct StrField huge *SortField;  // pointer to an array of fields used for
       int    TotalFields;      // total field in the field array
       int    TotalSortFields;  // total sort fields in the field array
       int    width;            // width of the control
       int    height;           // height of the control
       int    SortLevel;        // sort level for the current field
       int    valid;            // TRUE if the current field is valid

       // picture information
       struct StrPict pict;    // picture information
    };

typedef struct StrCtl far *LPCTL;


/*******************************************************************************
    Property Table
********************************************************************************/
PPROPINFO RvbProp[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_HWND,

    NULL
};

/*******************************************************************************
    Event Definitions
********************************************************************************/
EVENTINFO EventSelectField = {
    "SelectField",
    0,
    0,
    NULL,
    NULL
    };

EVENTINFO EventVerifyField = {
    "VerifyField",
    0,
    0,
    NULL,
    NULL
    };

EVENTINFO EventUnload = {
    "Unload",
    0,
    0,
    NULL,
    NULL
    };

EVENTINFO EventDrawPicture = {
    "DrawPicture",
    0,
    0,
    NULL,
    NULL
    };


/*******************************************************************************
    Event Table
********************************************************************************/
PEVENTINFO RvbEvent[] =
{
    (PEVENTINFO) &EventSelectField,
    (PEVENTINFO) &EventVerifyField,
    (PEVENTINFO) &EventUnload,
    (PEVENTINFO) &EventDrawPicture,

    NULL
};

/*******************************************************************************
    Function Prototypes
********************************************************************************/
#include "rvb_prot.h"
